platform.apilevel = '2.0'
require "physics"

--------------------Global variables
cpx=physics
screen=platform.window
Color = {
		red         = {255, 0, 0},
		orange      = {255, 165, 0},
		yellow      = {255, 255, 0},
		green       = {0, 255, 0},
		blue        = {0, 0, 255},
		white       = {255, 255, 255},
		black       = {0, 0, 0},
		paleblue    = {200, 200, 240},
		navy        = {20, 20, 138},
        maroon      = {150, 50, 50},
        gray        = {120, 120, 120},
        lightgray   = {200, 200, 200},
	}


marked=1 --index of the marked point
new=false --Was a point moved?
form=1--straight lines, ellipse, hyperbola or parabola
lines=1
ellipse=2
hyperbola=3
parabola=4

go=1
win=2
show=3

list={}--list of the 5 points which determine the conic section
list1={}--list after translation to the origin
list2={}--list after transformation to the points(1;0) and (0;1)
coeff={0,0,0,0,0,0}--the coefficients of the conic section
coeff1={0,0,0,0,0,0}
left={}-- rotational matrix 30 degrees left
right={}-- rotational matrix 30 degrees right
axes={{0,0},{0,0}}--the axes of the conic section
center=cpx.Vect(0,0)--the center of the conic section
straight1={1,2,3}
straight2={4,5}
ew0=0.0-- first eigenvalue
ew1=0.0-- second eigenvalue

function init()
   list[1]=cpx.Vect(1,0)
   --list[1]=cpx.Vect(0,0)
   list[2]=cpx.Vect(0,1)
   --list[2]=cpx.Vect(1,1)
   list[3]=cpx.Vect(-1,0)
   --list[3]=cpx.Vect(-1,1)
   list[4]=cpx.Vect(0,-1)
   --list[4]=cpx.Vect(2,4)
   list[5]=cpx.Vect(math.sqrt(2),math.sqrt(2))
   --list[5]=cpx.Vect(-2,4)
   compute()
   modus=go--Show conic section 
   W = platform.window:width()
   H = platform.window:height()
   or_x=W/2--x-coordinate of the origin on the screen
   or_y=H/2--y-ccordinate of the origin on the screen
   scale=W/16--pixels per mathematical unit
   local i
   for i=1,2 do
       left[i]={}
       right[i]={}
   end
   left[1][1]=math.cos(math.pi/6)
   left[2][2]=left[1][1]
   left[2][1]=math.sin(math.pi/6)
   left[1][2]=-math.sin(math.pi/6)  
   mtrans(left,right)
   new=false
   mouseD=false--is the mouse button down?
   message=""
   screen:invalidate()
   coordWin=cWindow(10,10,W*0.9,H*0.9,1)--window in which the ccordinates of the five points can be changed
end --init


function on.resize()	
	init()	
end

function on.construction()
   init()
end   

function on.restore()
   init()
end   
function showM(mess)
   message=mess
   screen:invalidate()
end   

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------Drawing procedures -----------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function on.paint(gc)
   if modus==go then
      local i
 --Draw the vertices  
      for i=1,5 do
         drawP(gc,list[i],marked==i)
      end -- for i
--Compute the coefficients of the conic section
      if new then
        compute()
        new=false
      end
   
 -- Draw conic section
      if form==ellipse then
         drawEllipse(gc)
      elseif form==hyperbola then
         drawHyperbola(gc)
      elseif form==parabola then
         drawParabola(gc)
      elseif form==lines then
         drawLines(gc)
      end                  
 
 --Draw message       
        gc:setColorRGB(0,0,0)
        gc:setFont("serif","r",H*0.05)
        v=list[marked]
  
        gc:drawString(message,W*0.05,H*0.95,top)
        gc:drawString(string.format("P%d(%.2f,%.2f)",marked,v:x(),v:y()),W*0.6,H*0.95,top)
 
    end  
 --Show coordinate window   
      
    if modus==win then
       coordWin:setVis(true) 
       coordWin:paint(gc)
    end    
      if modus==show then
         showCoeff(gc)
         
   end   
end      --on.paint

function showCoeff(gc)
   gc:setColorRGB(0,0,0)
   gc:setFont("serif","b",H*0.05)
   gc:drawString("Coefficients",W*0.05,H*0.05,"top")
   gc:setFont("serif","r",H*0.05)
   gc:drawString("a*x^2+b*x*y+c*y^2+d*x+e*y+f=0",W*0.05,H*0.15,"top")
   gc:drawString(string.format("a = %.4f",coeff1[1]),W*0.05,H*0.25,"top")
   gc:drawString(string.format("b = %.4f",coeff1[2]),W*0.05,H*0.32,"top")
   gc:drawString(string.format("c = %.4f",coeff1[3]),W*0.05,H*0.39,"top")
   gc:drawString(string.format("d = %.4f",coeff1[4]),W*0.05,H*0.46,"top")
   gc:drawString(string.format("e = %.4f",coeff1[5]),W*0.05,H*0.52,"top")
   gc:drawString(string.format("f = %.4f",coeff1[6]),W*0.05,H*0.60,"top")
   if math.abs(ew0)>1.0e-7 then
      gc:drawString(string.format("Semi-axis 1: %.4f",1.0/math.sqrt(math.abs(ew0))),W*0.05,H*0.70,"top")
   end
   if math.abs(ew1)>1.0e-7 then   
      gc:drawString(string.format("Semi-axis 2: %.4f",1.0/math.sqrt(math.abs(ew1))),W*0.05,H*0.77,"top")
   end   
   gc:drawString("Press Enter or ESC to return",W*0.05,H*0.92,"top")
end

function drawP(gc, v,m) --Draws a point (vector) v. m is a boolean indicating if v is marked
   gc:setColorRGB(0,0,0)
   local h=W/100
   local x1=or_x+v:x()*scale
   local y1=or_y-v:y()*scale-h
   local x2=x1
   local y2=or_y-v:y()*scale+h
   gc:drawLine(x1, y1, x2, y2)
   x1=or_x+v:x()*scale-h
   x2=or_x+v:x()*scale+h
   y1=or_y-v:y()*scale
   y2=y1
   gc:drawLine(x1, y1, x2, y2)
   if m then
      y1=y1-h
      gc:setColorRGB(255, 0, 0)
      gc:drawArc(x1, y1, 2*h+1, 2*h+1, 0, 360)
   end  
end --drawP

function drawL(gc, v1,v2, col) --Draws the connecting line between two vectors v1, v2 
   gc:setColorRGB(unpack(col))
   local x1=or_x+v1:x()*scale
   local y1=or_y-v1:y()*scale
   local x2=or_x+v2:x()*scale
   local y2=or_y-v2:y()*scale
   gc:drawLine(x1, y1, x2, y2)
end --drawL


function drawEllipse(gc)
   local i
   local phi=math.pi/30
   local f1,f2
   local a1,a2,z1,z2,mid
   ew0=-coeff[1]/coeff[6]
   ew1=-coeff[3]/coeff[6]
   f1=1.0/math.sqrt(math.abs(coeff[1]))
   f2=1.0/math.sqrt(math.abs(coeff[3]))
   f1=f1*math.sqrt(math.abs(coeff[6]))
   f2=f2*math.sqrt(math.abs(coeff[6]))
   a1=cpx.Vect(f1*axes[1][1],f1*axes[2][1])
   a2=cpx.Vect(f2*axes[1][2],f2*axes[2][2])
   
   z1=center:add(a1)
   for i=1,60 do
       z2=center:add(a1:mult(math.cos(i*phi)))
       z2=z2:add(a2:mult(math.sin(i*phi)));
       drawL(gc,z1,z2,{0,0,0});
       z1=z2;
   end        
end--drawEllipse

function drawHyperbola(gc)
    local f1,f2
    local i
    axtr={{0,0},{0,0}};
    local a1=cpx.Vect(0,0)
    local a2=cpx.Vect(0,0)
    local z1=cpx.Vect(0,0)
    local z2=cpx.Vect(0.0)
    mtrans(axes,axtr);
    if math.abs(coeff[6])>1.0e-6 then
        coeff[1]=-coeff[1]/coeff[6];
        coeff[3]=-coeff[3]/coeff[6];
        coeff[6]=-1.0;
        ew0=coeff[1];
        ew1=coeff[3];
    end--if math.abs     
     
    f1=1.0/math.sqrt(math.abs(coeff[1]));
    f2=1.0/math.sqrt(math.abs(coeff[3]));
    a1=cpx.Vect(f1*axes[1][1],f1*axes[2][1]);
    a2=cpx.Vect(f2*axes[1][2],f2*axes[2][2]);
    if coeff[1]>0 then
       z1=center:add(a1:mult(math.cosh(-60*0.06)))
       z1=z1:add(a2:mult(math.sinh(-60*0.06)))
       for i=-59, 60 do 
           z2=center:add(a1:mult(math.cosh(i*0.06)))
           z2=z2:add(a2:mult(math.sinh(i*0.06)))
           drawL(gc,z1,z2,{255,0,0});
           z1=z2;
       end--for i        
       z1=center:sub(a1:mult(math.cosh(-60*0.06)))
       z1=z1:sub(a2:mult(math.sinh(-60*0.06)))
       for i=-59,60 do
           z2=center:sub(a1:mult(math.cosh(i*0.06)))
           z2=z2:sub(a2:mult(math.sinh(i*0.06)));
           drawL(gc,z1,z2,{0,255,0});
           z1=z2;
       end  
    else
        z1=center:add(a1:mult(math.sinh(-60*0.06)))
        z1=z1:add(a2:mult(math.cosh(-60*0.06)))
        for i=-59,60 do
           z2=center:add(a1:mult(math.sinh(i*0.06)))
           z2=z2:add(a2:mult(math.cosh(i*0.06)))
           drawL(gc,z1,z2,{0,0,0});
           z1=z2;
        end --for i
        z1=center:sub(a1:mult(math.sinh(-60*0.06)))
        z1=z1:sub(a2:mult(math.cosh(-60*0.06)))        
       
        for i=-59, 60 do
           z2=center:sub(a1:mult(math.sinh(i*0.06)))
           z2=z2:sub(a2:mult(math.cosh(i*0.06)))
           drawL(gc,z1,z2,{0,0,255});
           z1=z2;
        end --for i  
    end--else             
       

end--drawHyperbola

function drawParabola(gc)
    local i
    local a1=cpx.Vect(0,0)
    local a2=cpx.Vect(0,0)
    local z1=cpx.Vect(0,0)
    local z2=cpx.Vect(0,0)
    local mid=cpx.Vect(0,0)
    local x,y,a,c,d,e,f
    a=coeff[1];
    c=coeff[3];
    d=coeff[4];
    e=coeff[5];
    f=coeff[6];

    a1=cpx.Vect(axes[1][1],axes[2][1])
    a2=cpx.Vect(axes[1][2],axes[2][2]);
    if math.abs(a)>1.0e-6 and math.abs(e)>1.0e-6 then
        ew0=-a/a
        ew1=0
        x=-30*0.1
        y=-x*x*a/e-f/e
        z1=center:add(a1:mult(x))
        z1=z1:add(a2:mult(y))
       
        for i=-29,30 do
            x=i*0.1;
            y=-x*x*a/e-f/e;
            z2=center:add(a1:mult(x))
            z2=z2:add(a2:mult(y))
            drawL(gc,z1,z2,{0,0,0});
            z1=z2;
         end --for i   
    end  --if math.abs           
    if math.abs(c)>1.0e-6 and math.abs(d)>1.0e-6 then
        ew0=0;
        ew1=-c/d;
        y=-30*0.1;
        x=-y*y*c/d-f/d;
        z1=center:add(a1:mult(x))
        z1=z1:add(a2:mult(y))
        for i=-29,30 do
            y=i*0.1;
            x=-y*y*c/d-f/d;
            z2=center:add(a1:mult(x))
            z2=z2:add(a2:mult(y))
            drawL(gc,z1,z2,{0,0,0});
            z1=z2;
        end--for i
    end --if math.abs            
    
end--drawParabola()

function drawLines(gc)
    local v0=cpx.Vect(0,0)
    local v1=cpx.Vect(0,0)
    local z1=cpx.Vect(0,0)
    local z2=cpx.Vect(0,0)
    v0=list[straight1[1]];
    v1=list[straight1[2]]:sub(v0)
    z1=v0:sub(v1:mult(5.0))
    z2=v0:add(v1:mult(5.0))
    drawL(gc,z1,z2,{0,0,0})
    v0=list[straight2[1]];
    v1=list[straight2[2]]:sub(v0)
    z1=v0:sub(v1:mult(5.0))
    z2=v0:add(v1:mult(5.0))
    drawL(gc,z1,z2,{0,0,0})
end--drawLines    
    
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------- Mathematical routines ------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--function principalAxes (coeff, ev,m)
function principalAxes (coeff, ev)
--principal axes transformation for a quadric with coefficients coeff
--The princioal axes are written to ev, the eigenvalues to coeff[1] and coeff[2], the coordinates of the center to m

    local  test
    local mat={{0,0},{0,0}}
    local a,c,d,e,f,re,im;
    local z1=cpx.Vect(0,0)
    local mid=cpx.Vect(0,0)
       
    mat[1][1]=coeff[1]
    mat[2][1]=0.5*coeff[2]
    mat[1][2]=0.5*coeff[2];
    mat[2][2]=coeff[3];
 --compute eigenvalues and eigenvectors   
    test=eigenv(mat,ev)
    a=mat[1][1];
    c=mat[2][2];
    d=coeff[4]*ev[1][1]+coeff[5]*ev[2][1]
    e=coeff[4]*ev[1][2]+coeff[5]*ev[2][2]
    coeff[1]=a;
    coeff[2]=0.0;
    coeff[3]=c;
 ---[[   
    if math.abs(a)>1.0e-6 and math.abs(c)>1.0e-6 then
        f=coeff[6]-0.25*d*d/a-0.25*e*e/c
        coeff[6]=f
        coeff[4]=0.0
        coeff[5]=0.0
        re=-0.5*d/a  --x-coordinate of center
        im=-0.5*e/c  --y-coordinate of center
        mid=cpx.Vect(re,im)    
    elseif math.abs(c)>1.0e-6 then
        coeff[1]=0.0
        f=coeff[6]-0.25*e*e/c
        coeff[6]=f
        coeff[5]=0.0
        coeff[4]=d
        im=-0.5*e/c
        mid=cpx.Vect(0.0,im)
    elseif math.abs(a)>1.0e-6 then
        coeff[3]=0.0
        f=coeff[6]-0.25*d*d/a
        coeff[6]=f
        coeff[4]=0.0
        coeff[5]=e---
        re=-0.5*d/a
        mid=cpx.Vect(re,0.0)
    end
---]]    
    --m=multm(ev,mid)
    return test , multm(ev,mid)   
end--principalAxes   

function compute()
   local erg=0
   local z1= cpx.Vect(0,0)
   erg=testLines();
   if erg==1 then
	   form=lines
   else   
	   computeCoeff();
	   --erg=principalAxes(coeff,axes,center);
	   erg, center = principalAxes(coeff, axes)--------------------------------------------------------
	   if erg==1 then
          print("Fehler in eigenv") 
	   end
	   
       
	   if coeff[1]*coeff[3]==0.0 then
	      form=parabola
	   elseif coeff[1]*coeff[3]>0.0 then
          form=ellipse;
       else
          form=hyperbola;
       end         
    end--else	   
end--compute()    

function crossp(a, b, c) --The cross product of 3-dimensional vectors a, b is written to c
    c[1]=a[2]*b[3]-a[3]*b[2];
    c[2]=a[3]*b[1]-a[1]*b[3];
    c[3]=a[1]*b[2]-a[2]*b[1];
end--crossp    

function matmult(a, b, c) --Multiplies 2x2 matrices a and b, writes to c
    local i,j,k
    for i=1,2 do
       for j=1,2 do
           c[i][j]=0
           for k=1,2 do
              c[i][j]=c[i][j]+a[i][k]*b[k][j]
           end--k   
       end --j
    end--i      
end--matmult

function computeCoeff()
    local a={{0,0},{0,0}}
    local b={{0,0},{0,0}}
    local btrans={{0,0},{0,0}}
    local mat1={{0,0},{0,0}}
    local mat2={{0,0},{0,0}}
    local mat3={{0,0},{0,0}}
    local v1={0,0,0}
    local v2={0,0,0}
    local coe={0,0,0}
    local i=0
    --transfer first point to origin
    for i=1,5 do
       list1[i]=list[i]:sub(list[1])
    end   
    --transfer list1[2] to the point (1,0) and list1[3] to the point (0,1)    
    a[1][1]=list1[2]:x();
    a[2][1]=list1[2]:y();
    a[1][2]=list1[3]:x();
    a[2][2]=list1[3]:y();
    invmat(a,b)
    list2[1]=cpx.Vect(0.0,0.0)
    list2[2]=cpx.Vect(1.0,0.0)
    list2[3]=cpx.Vect(0.0,0.1);
    list2[4]=multm(b,list1[4]);
    list2[5]=multm(b,list1[5]);
    v1[1]=list2[4]:x()*list2[4]:x()-list2[4]:x()
    v1[2]=list2[4]:x()*list2[4]:y();
    v1[3]=list2[4]:y()*list2[4]:y()-list2[4]:y()
    v2[1]=list2[5]:x()*list2[5]:x()-list2[5]:x()
    v2[2]=list2[5]:x()*list2[5]:y()
    v2[3]=list2[5]:y()*list2[5]:y()-list2[5]:y()
    --Solution of the two equations as cross product of their coefficients
    crossp(v1,v2,coe)
    
    --reverse linear transformations
    mat1[1][1]=coe[1];
    mat1[2][2]=coe[3];
    mat1[2][1]=0.5*coe[2]
    mat1[1][2]=mat1[2][1]
    mtrans(b,btrans)
    matmult(mat1,b,mat2)
    matmult(btrans,mat2,mat3)
    
    coeff[1]=mat3[1][1];
    coeff[2]=2.0*mat3[2][1];
    coeff[3]=mat3[2][2];
    --computation of the linear coefficients
    coeff[4]=-coe[1]*b[1][1]-coe[3]*b[2][1];
    coeff[5]=-coe[1]*b[1][2]-coe[3]*b[2][2];
    
    --reverse the translattion to the origin
    --compute the absolute coefficient
    
    coeff[6]=coeff[1]*list[1]:x()*list[1]:x()
              +coeff[2]*list[1]:x()*list[1]:y()
                +coeff[3]*list[1]:y()*list[1]:y()
                -coeff[4]*list[1]:x()-coeff[5]*list[1]:y();
    
    --computation of the linear coefficients
    coeff[4]=coeff[4]-2.0*coeff[1]*list[1]:x()-coeff[2]*list[1]:y();
    coeff[5]=coeff[5]-2.0*coeff[3]*list[1]:y()-coeff[2]*list[1]:x();
    
    if math.abs(coeff[6])>1.0e-6 then
        for i=1,5 do
           coeff[i]=-coeff[i]/coeff[6];
        end --for   
        coeff[6]=-1.0;
    end --if          
    --store the initial coefficients in coeff1 
    for i=1,6 do
       coeff1[i]=coeff[i];
    end   
    --test
 --[[   for i=1,5 do
        local re=list[i]:x();
        local im=liste[i]:y();
        local wert=coeff[1]*re*re+coeff[2]*re*im+koeff[3]*im*im +coeff[4]*re
              +coeff[5]*im+coeff[6]
        if math.abs(wert)>1.0e-5 then
               print("Fehler beim Koeffizienten berechnen");
               break;
        end--if        
        end--for
 --]]   
        
end--computeCoeff

function testLines() --return 1, if 3 point lie on a straight line, 0 if not
    local i, j, k,m
    local d1,d2
    local h1,h2,h3,h4,h5,h6
    local mat={{0,0},{0,0}}
    local erg=0
    local v1=cpx.Vect(0,0)
    local v2=cpx.Vect(0,0)
    local n1=cpx.Vect(0,0)
    local n2=cpx.Vect(0,0)
    for i=1,3 do
       if erg==1 then break end
       for j=i+1,4 do
          if erg==1 then break end 
          for k=j+1,5 do
              if math.abs(det(list[k]:sub(list[i]),list[j]:sub(list[i])))<1.0e-6 then--------------------------------
                  erg=1
                  straight1[1]=i;
                  straight1[2]=j;
                  straight1[3]=k;
                  
                  --store the two other indices in straight2
                  for  m=1,5 do
                     if m~=straight1[1] and m~=straight1[2] and m~=straight1[3] then
                         straight2[1]=m
                         break
                     end--if
                  end--for       
                  for  m=1,5 do   
                     if m~=straight1[1] and m~=straight1[2] and m~=straight1[3] and m~=straight2[1] then
                         straight2[2]=m;
                         break;
                     end--if 
                  end--for m
              end--if math.abs    
           end--for k
       end--for j       
    end--for i           
    if erg==1 then
       form=lines;
     --compute coefficients
       v1=list[straight1[2]]:sub(list[straight1[1]]);   
       v2=list[straight2[2]]:sub(list[straight2[1]]);
       n1=cpx.Vect(-v1:x(),v1:x());  
       n2=cpx.Vect(-v2:y(),v2:x());
       d1=-list[straight1[1]]:dot(n1)
       d2=-list[straight2[1]]:dot(n2)

       h1=n1:x()*n2:x()
       coeff[1]=h1
       coeff1[1]=h1
       h2=n1:x()*n2:y()+n1:y()*n2:x()
       coeff[2]=h2
       coeff1[2]=h2
       h3=n1:y()*n2:y()
       coeff[3]=h3
       coeff1[3]=h3 
       h4=n1:x()*d2+n2:x()*d1
       coeff[4]=h4
       coeff1[4]=h4
       h5=n1:y()*d2+n2:y()*d1
       coeff[5]=h5
       coeff1[5]=h5
       h6=d1*d2
       coeff[6]=h6
       coeff1[6]=h6  
       if math.abs(coeff[6])>1.0e-6 then
          for i=1,6 do
             coeff[i]=coeff[i]/coeff[6];
             coeff1[i]=coeff[i];
          end--for
       end--if   
     --compute eigenvalues
       mat[1][1]=coeff[1]
       mat[1][2]=0.5*coeff[2]
       mat[2][1]=0.5*coeff[2];
       mat[2][2]=coeff[3];
       i=eigenv(mat,axes);
       ew0=mat[1][1];
       ew1=mat[2][2];------------------------   
    end --if erg==1    
    return erg              
    
end--testLines()      

function det(u,v)--return the determinant of two vectors which are considered as a matrix
   return u:x()*v:y()-u:y()*v:x()
end   

function mtrans(a,b)--Writes the transpose of 2x2 matrix a to b
   local i, j
   for i=1,2 do
      for j=1,2 do
         b[j][i]=a[i][j]
      end
   end      
end

function multm(a,v)--computes a*v, where a is a 2X2-matrix and v a vector
   local x,y
   x=a[1][1]*v:x()+a[1][2]*v:y()
   y=a[2][1]*v:x()+a[2][2]*v:y()
   return cpx.Vect(x,y)
end

function invmat(a,b)--inverts 2X2 matrix a, writes to b
    local i, j, det
    det = a[1][1]*a[2][2]-a[2][1]*a[1][2]
    b[1][1]=a[2][2]
    b[1][2]=-a[1][2]
    b[2][1]=-a[2][1]
    b[2][2]=a[1][1]
    if (det~=0) then
       for i=1,2 do
          for j=1,2 do
             b[i][j]=b[i][j]/det
          end --for j
       end --for i
    end--if        
    return det;         
end--invmat    


function eigenv(mat, ev)--computes eigenvalues and eigenvectors of symmetric 2x2 matrix mat
    local i,j,test;
    local a,b,c,l0, l1, root
    local trans={{0,0},{0,0}}
    local inp={{0,0},{0,0}}
    local erg1={{0,0},{0,0}}
    local erg2={{0,0},{0,0}}
    for i=1,2 do
       for j=1,2 do
          inp[i][j]=mat[i][j]
       end--j
    end--i      
    a=mat[1][1];
    b=mat[1][2];
    c=mat[2][2];
    local norm
    root = math.sqrt(a*a+4.0*b*b+c*c-2.0*a*c);
    l0=0.5*(a+c-root)
    l1=0.5*(a+c+root)
    if root<1.0e-6 then--eigenvalues are equal 
        ev[1][1]=1.0
        ev[2][2]=1.0
        ev[1][2]=0.0
        ev[2][1]=0.0
    elseif math.abs(b)<1.0e-6 then --matrix already in diagonal form 
        l0=a
        l1=c;
        ev[1][1]=1.0
        ev[2][2]=1.0
        ev[1][2]=0.0
        ev[2][1]=0.0        
    else        
       norm=0.5*(a-c-root);
       norm=norm*norm;
       norm=norm+b*b;
       norm=math.sqrt(norm);
       ev[1][2]=-b/norm;
       ev[2][2]=0.5*(a-c-root)/norm;
       ev[2][1]=-ev[1][2];
       ev[1][1]=ev[2][2];
    end       
    mat[1][1]=l0;
    mat[2][2]=l1;
    mat[2][1]=0.0
    mat[1][2]=0.0;
    
    --test
    test = 0
    mtrans(ev,trans)
    matmult(inp,ev,erg1)
    matmult(trans,erg1,erg2)
    erg2[1][1]=erg2[1][1]-l0;
    erg2[2][2]=erg2[2][2]-l1;
    for i=1,2 do
       for j=1,2 do
          if math.abs(erg2[i][j])>1.0e-5 then
              test=1
              break
          end--if    
       end--for j
    end--for i    
    return test;
end--eigenv     
    

 



---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------------------------------------------------------------------- key events---------------------------------------------------------------------------------------------------------
---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function on.arrowRight()
   if modus==go then
      local h=cpx.Vect(0.1,0)
      list[marked]=list[marked]:add(h)
      new=true
      screen:invalidate()
   end   
end --on.arrowRight

---[[

function on.arrowLeft()
   if modus==go then
      local h=cpx.Vect(0.1,0)
      list[marked]=list[marked]:sub(h)
      new=true
      screen:invalidate()
   end   
end --on.arrowLeft
---]]
function on.arrowUp()
   if modus==go then
      local h=cpx.Vect(0,0.1)
      list[marked]=list[marked]:add(h)
      new=true
      screen:invalidate()
   elseif modus==win then
      coordWin:swapFocusRev()   
   end 
end --on.arrowUp

function on.arrowDown()
   if modus==go then
      local h=cpx.Vect(0,0.1)
      list[marked]=list[marked]:sub(h)
      new=true
      screen:invalidate()
   elseif modus==win then
      coordWin:swapFocus()   
   end   
end --on.arrowDown

function on.tabKey()
    if modus==go then 
       marked=marked%5+1
    elseif modus==win then
       coordWin:swapFocus()
    end        
    screen:invalidate()  
end --on.tabKey

function on.backtabKey()
   if modus==go then
      marked=(marked+3)%5+1
   elseif modus==win then
      coordWin:swapFocusRev()
   end      
   screen:invalidate()      
end--on.backtabKey


function on.enterKey()   
   if modus==win then
       local x, y
       
       x,y=coordWin:getInput()
       if x~=nil and y~=nil then
          list[marked]=cpx.Vect(x,y)
          new=true
          modus=go
          coordWin:setMessage("")
          coordWin:hide()
       elseif x==nil then
          coordWin:setMessage("Invalid input for x coordinate")    
       else
          coordWin:setMessage("Invalid input for y coordinate")
       end      
   elseif modus==go then
       modus=win
       coordWin:setNumber(marked)
       coordWin:swapFocus()
       coordWin:setValues()
   elseif modus==show then
       modus=go        
   end --if
   screen:invalidate()
end --on.enterKey

function on.escapeKey()
   if modus==win then
      modus=go
      coordWin:hide()
      screen:invalidate()
   elseif modus==go then
      init()   
   elseif modus==show then
    modus=go
    screen:invalidate()   
   end --if
end --on.escapeKey()      

function on.charIn(char)
   if char=="*" then onZoomIn() 
   elseif char=="/" then onZoomOut()
   elseif char=="8" then onMoveUp()         
   elseif char=="2" then onMoveDown()
   elseif char=="4" then onMoveLeft()
   elseif char=="6" then onMoveRight()
   elseif char=="c" then onCentralise()
   elseif char=="l" then rotateLeft()
   elseif char=="r" then rotateRight()
   elseif char=="a" then onAxes()
   end
end--on.charIn

---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------Mouse events -----------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function on.mouseDown(x,y)
   if x==0 and y==0 then return end --Do nothing if the click key is pressed
   local res, v  
   
   res = search(x,y)
   if res>0 then
      marked=res
      mouseD=true
      screen:invalidate()
   end      
end--onMouseDown()

function search(x,y)
  local rx, ry, i, res, v
  rx=(x-or_x)/scale
  ry=(or_y-y)/scale
  v=cpx.Vect(rx,ry)
  for i=1, 5 do
     if list[i]:dist(v)<0.2 then
        return i
     end  --if
  end--for  
  return 0
end---seach(x,y)

function on.mouseUp()
   mouseD=false
end

function on.mouseMove(x,y)
   local rx, ry,  res, v
   rx=(x-or_x)/scale
   ry=(or_y-y)/scale
   v=cpx.Vect(rx,ry)
   if mouseD then
      list[marked]=v
      new=true
      screen:invalidate()
   end   
end   
------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------Menu functions and definition of menu-------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function onZoomIn()
   scale=scale*2
   screen:invalidate()
 end

function  onZoomOut()
   scale=0.5*scale
   screen:invalidate()
end   

function onMoveLeft()
   or_x=or_x-W/16
   screen:invalidate()
 end--onMoveLeft
 
 function onMoveRight()
    or_x=or_x+W/16
    screen:invalidate()
 end--onMoveRight
 
 function onMoveUp()
     or_y=or_y-H/16
     screen:invalidate()
  end--onMoveUp     
  
 function onMoveDown()
    or_y=or_y+H/16
    screen:invalidate()
end--onMoveDown                  



function onCentralise()
   local i
   for i=1,#list do
         list[i]=list[i]:sub(center)
    end
    new=true  
    screen:invalidate()      
end   

function showCoefficients()
   modus=show
   screen:invalidate()
end

function rotateLeft()
local i
   for i=1,#list do
      list[i]=multm(left,list[i])
   end
   new=true
   screen:invalidate()   
end

function rotateRight()
   local i
   for i=1,#list do
      list[i]=multm(right,list[i])
   end
   new=true
   screen:invalidate()
end

function onAxes()-- rotate so that the principal axes coincide with the coordinate axes
   local rot={{0,0},{0,0}}
   mtrans(axes, rot)
   local i
   for i=1,#list do
      list[i]=multm(rot,list[i])
   end
   new=true
   screen:invalidate()
end      

      
menu={
        {"Values",
           {"New (ESC)", init},
           {"Coefficients", showCoefficients}        
        },   
        {"Rotation",
           {"Left (l)",rotateLeft},
           {"Right (r)",rotateRight},
           {"Axes->coordinate axes (a)",onAxes}
        },
       
        {"View",
           {"Zoom in (*)", onZoomIn},
           {"Zoom out (/)", onZoomOut},
           {"Move left (4)", onMoveLeft},
           {"Move right (6)", onMoveRight},
           {"Move up (8)", onMoveUp},
           {"Move down (2)", onMoveDown}, 
           {"Centralise (c)", onCentralise}
        }
        
     }--menu
toolpalette.register(menu)

-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
---------------------------------------------- class cWindow ---------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
cWindow = class()--a frame with two rich text fields that allow the user to input new coordinates for a vertex

function cWindow:init(x,y,width, height, number)
   self.x=x
   self.y=y
   self.width=width
   self.height=height
   self.number=number
   self.message=""
   self.TextBox1=D2Editor.newRichText()
   self.TextBox2=D2Editor.newRichText()
   self.TextBox1:move(self.x+W/20,self.y+2.5*H/12)
   self.TextBox2:move(self.x+W/20,self.y+5*H/12)
   self.TextBox1:resize(W/2,H/8)
   self.TextBox2:resize(W/2,H/8)
   self.TextBox1:setBorderColor(0)
   self.TextBox2:setBorderColor(0)
   self.TextBox1:setBorder(1)
   self.TextBox2:setBorder(1)
   self.TextBox1:setFontSize(0.05*H)
   self.TextBox2:setFontSize(0.05*H)
   self.TextBox1:setTextColor(000*000*000)
   self.TextBox2:setTextColor(000*000*000)
   self.TextBox1:setVisible(false)
   self.TextBox2:setVisible(false)
end

function cWindow:paint(gc)
   ---gc:clipRect("set",self.x,self.y,self.width,self.height)
   gc:setColorRGB(0,0,0)
   gc:setFont("serif","r",H*0.05)
   gc:drawRect(self.x,self.y,self.width,self.height)
   gc:drawString("Vertex "..self.number,self.x+3,self.y,"top" )
   gc:drawString("Coordinates",self.x+3,self.y+H/12,"top")
   gc:drawString("x: ",self.x+3,self.y+2.5*H/12,"top")
   gc:drawString("y: ",self.x+3,self.y+5*H/12,"top")
 
   if self.TextBox1:hasFocus() or self.TextBox2:hasFocus() then
      gc:setFont("serif","r",H*0.05)
      gc:drawString("Press the tab or arrow up/down key",self.x+3,self.y+8.5*H/12,"top")
   else
      gc:setColorRGB(0,0,0)
      gc:setFont("serif","b",H*0.05)
      gc:drawString("Press Enter to accept or Esc to cancel",self.x+3,self.y+8.5*H/12,"top")
   end      
   
   gc:setFont("serif","r",H*0.05)
   gc:drawString(self.message,self.x+3,self.y+9.5*H/12,"top")
   
end     

function cWindow:setNumber(number)
   self.number=number
end   
function cWindow:hide()
   self.TextBox1:setVisible(false)
   self.TextBox2:setVisible(false)
   self.TextBox1:setFocus(false)
   self.TextBox2:setFocus(false)
end

function cWindow:swapFocus()
---[[
   if self.TextBox1:hasFocus() then
      self.TextBox1:setFocus(false)
      self.TextBox2:setFocus(true)
   elseif self.TextBox2:hasFocus() then   
      self.TextBox2:setFocus(false)
   else
      self.TextBox1:setFocus(true)
   end
   ---]]
end   --function swapFocus

function cWindow:swapFocusRev()
---[[
   if self.TextBox1:hasFocus() then
      self.TextBox1:setFocus(false)
   elseif self.TextBox2:hasFocus() then   
      self.TextBox2:setFocus(false)
      self.TextBox1:setFocus(true)
   else
      self.TextBox2:setFocus(true)
   end
   ---]]
end   --function swapFocusRev

function cWindow:setVis(b)
   self.TextBox1:setVisible(b)
   self.TextBox2:setVisible(b)
end  

function cWindow:setValues()
 
   self.TextBox1:setText(string.format("%.4f",list[self.number]:x()))
   self.TextBox2:setText(string.format("%.4f",list[self.number]:y()))
end   

function cWindow:getInput()
   return math.eval(self.TextBox1:getText()), math.eval(self.TextBox2:getText())
end   

function cWindow:setMessage(str)
   self.message=str
end   
   
   
      